// NOTE: it is recommended to use this even if you don't understand the following code.

using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;

namespace pizza {

    class Program {
        static void Main(String[] args) {
            StreamReader streamReader = new StreamReader(Console.OpenStandardInput());
            StreamWriter streamWriter = new StreamWriter(Console.OpenStandardOutput());
            // uncomment the two following lines if you want to read/write from files
            // streamReader = new StreamReader("input.txt");
            // streamWriter = new StreamWriter("output.txt");

            IEnumerator<String> it = GetEnumerator(streamReader);

            int N = Convert.ToInt32(Next(it));
            int M = Convert.ToInt32(Next(it));
            int Q = Convert.ToInt32(Next(it));

            int[] A = new int[N], B = new int[N];
            for (int i = 0; i < N; ++i) {
                A[i] = Convert.ToInt32(Next(it));
                B[i] = Convert.ToInt32(Next(it));
            }

            int[] K1 = new int[M];
            int[,] P = new int[M, N];
            for (int i = 0; i < M; ++i) {
                K1[i] = Convert.ToInt32(Next(it));
                for (int j = 0; j < K1[i]; ++j)
                    P[i, j] = Convert.ToInt32(Next(it));
            }

            int[] K2 = new int[Q];
            int[,] QS = new int[Q, N];
            for (int i = 0; i < Q; ++i) {
                K2[i] = Convert.ToInt32(Next(it));
                for (int j = 0; j < K2[i]; ++j)
                    QS[i, j] = Convert.ToInt32(Next(it));
            }

            int[] ANS = new int[Q];


            // INSERT YOUR CODE HERE


            for (int i = 0; i < Q; ++i)
                streamWriter.WriteLine($"{ANS[i]}");

            streamReader.Close();
            streamWriter.Close();
        }

        static IEnumerator<String> GetEnumerator(StreamReader sr) {
            String line;
            while ((line = sr.ReadLine()) != null) {
                String[] tokens = line.Split(' ').Where(t => t.Length > 0).ToArray();
                foreach (String t in tokens) {
                    yield return t;
                }
            }
        }

        static String Next(IEnumerator<String> iterator) {
            return iterator.MoveNext() ? iterator.Current : null;
        }
    }
}
